/* jshint esversion : 6 */

const cron = require('node-cron');

const KROONS = {};


class Kroons {

    static set({ taskName, cronExpression, scheduled = true, timezone }) {
        return new Promise(resolve => {
            if (!KROONS[taskName]) {
                if (cron.validate(cronExpression))
                    KROONS[taskName] = cron.schedule(cronExpression, () => resolve({ msg: 'cron schedule', taskName }), { scheduled, timezone });
                else
                    throw { msg: `"${cronExpression}" is not a valid path`, taskName };
            } else
                resolve({ msg: 'cron schedule', taskName });
        });
    }

    static stop(taskName) {
        return new Promise(resolve => {
            const $cron = KROONS[taskName];
            try {
                $cron.stop();
                resolve({ msg: 'cron stop succesfly', taskName });
            } catch (ev) {
                throw { msg: 'cron stop error', taskName, ev };
            }
        });
    }

    static destroy(taskName) {
        return new Promise(resolve => {
            const $cron = KROONS[taskName];
            try {
                $cron.destroy();
                delete KROONS[taskName];
                resolve({ msg: 'cron destroy succesfly', taskName });
            } catch (ev) {
                throw { msg: 'cron destroy error', taskName, ev };
            }
        });
    }

}



module.exports = Kroons;