/* jshint esversion : 6 */
/* jshint ignore : start */
const testConnection = require('../../network/test-connection');
//
const ObjectStore = require('./ObjectStore');
class ObjectStoreQueries extends ObjectStore {
    constructor(o) {
        super(o);
    }

    //
    add(data, key, shared) {
        return Insert.call('add', data, key, shared);
    }
    put(data, key, shared) {
        return Insert.call('put', data, key, shared);
    }

    //
    get(key, shared) {
        return Get.call(this, 'get', key, shared).catch(e => { throw e; });
    }
    getKey(key, shared) {
        return Get.call(this, 'getKey', key, shared).catch(e => { throw e; });
    }

    //
    getAll(key, count, shared) {
        return GetAll.call(this, 'getAll', key, count, shared).catch(e => { throw e; });
    }
    getAllKeys(key, count, shared) {
        return GetAll.call(this, 'getAllKeys', key, count, shared).catch(e => { throw e; });
    }

    //
    delete(key, shared) {
        return Delete.call(this, key, shared);
    }
    clear(shared) {
        return Delete.call(this, null, shared);
    }

    //
    cursorUpdate(query) {
        return CursorQueries.call(this, 'Update', query);
    }
    cursorDelete(query) {
        return CursorQueries.call(this, 'Delete', query);
    }
}
module.exports = ObjectStoreQueries;
//
//
//
const queries = require('../../queries');

function Insert(cmd, data, key, shared) {
    const req = {
        q: 'Insert',
        dbName: this.dbName,
        storeNames: this.storeName,
        query: { cmd, data, key },
        shared
    };
    try {
        return this.webWorkers.wq({ path: 'queries', req });
    } catch (err) {
        return queries.Insert(req);
    }
}

function Get(cmd, key, shared) {
    const req = {
        q: 'Get',
        dbName: this.dbName,
        storeNames: this.storeName,
        query: { cmd, key },
        shared
    };
    try {
        return this.webWorkers.wq({ path: 'queries', req });
    } catch (err) {
        return queries.Get(req);
    }
}

function GetAll(cmd, key, count, shared) {
    const req = {
        q: 'GetAll',
        dbName: this.dbName,
        storeNames: this.storeName,
        query: { cmd, key, count },
        shared
    };
    try {
        return this.webWorkers.wq({ path: 'queries', req });
    } catch (err) {
        return queries.GetAll(req);
    }
}

function Delete(key, shared) {
    const req = {
        q: 'Delete',
        dbName: this.dbName,
        storeNames: this.storeName,
        query: { key },
        shared
    };
    try {
        return this.webWorkers.wq({ path: 'queries', req });
    } catch (err) {
        return queries.Delete(req);
    }

}


function CursorQueries(cmd, query) {
    const req = {
        q: `Cursor${cmd}`,
        dbName: this.dbName,
        storeNames: this.storeName,
        query,
        shared
    };
    try {
        return this.webWorkers.wq({ path: 'queries', req });
    } catch (err) {
        return queries[req.q](req);
    }

}