/* jshint esversion : 6 */
/* jshint ignore : start */

module.exports = function(a, b) {
    //
    let imageAddr = "http://www.kenrockwell.com/contax/images/g2/examples/31120037-5mb.jpg";
    let downloadSize = 4995374; //bytes
    //
    let speedBps, speedKbps, speedMbps;
    //
    class TestConnection {
        constructor(imageAddr, downloadSize) {
            this.imageAddr = imageAddr;
            this.downloadSize = downloadSize;
        }

        set imageAddr(a) {
            imageAddr = a || "http://www.kenrockwell.com/contax/images/g2/examples/31120037-5mb.jpg";;
        }

        set downloadSize(s) {
            downloadSize = s || 4995374;
        }

        test() {
            return new Promise(resolve => {
                const InitiateSpeedDetection = () => window.setTimeout(async() => {
                    try {
                        const r = await MeasureConnectionSpeed();
                        resolve(r);
                    } catch (err) {
                        throw err;
                    }
                }, 1);
                //
                if (window.addEventListener) {
                    window.addEventListener('load', InitiateSpeedDetection, false);
                } else if (window.attachEvent) {
                    window.attachEvent('onload', InitiateSpeedDetection);
                }
            });
        }

        get speedBps() { return speedBps; }

        get speedKbps() { return speedKbps; }

        get speedMbps() { return speedMbps; }

        get connectionType() {
            return new Promise(async resolve => {
                const { speedMbps } = await this.test();

                try {
                    if (window.addEventListener) {
                        window.removeEventListener('load', InitiateSpeedDetection, false);
                    } else if (window.attachEvent) {
                        window.detachEvent('onload', InitiateSpeedDetection);
                    }
                } catch (e) {
                    void 0;
                }

                if (speedMbps <= 0.3) return resolve("2G");
                if (speedMbps > 0.3 && speedMbps <= 8) return resolve("3G");
                if (speedMbps > 8 && speedMbps <= 979) return resolve("4G");
                if (speedMbps > 979 && speedMbps <= 10000) return resolve("5G");
                if (speedMbps > 10000) return resolve("Very speed");

            });
        }
    }


    return new TestConnection(a, b);


    function MeasureConnectionSpeed() {

        return new Promise(resolve => {

            let startTime, endTime;
            const download = new Image();

            download.onload = function() {
                endTime = (new Date()).getTime();
                showResults();
            };

            download.onerror = function(err, msg) {
                console.log(msg);
                throw err;
            };

            startTime = (new Date()).getTime();
            const cacheBuster = `?nnn=${startTime}`;
            download.src = imageAddr + cacheBuster;

            function showResults() {
                const duration = (endTime - startTime) / 1000;
                const bitsLoaded = downloadSize * 8;
                //
                speedBps = (bitsLoaded / duration).toFixed(2);
                speedKbps = (speedBps / 1024).toFixed(2);
                speedMbps = (speedKbps / 1024).toFixed(2);
                //
                resolve({ speedBps, speedKbps, speedMbps });
            }
        });
    }


};