/* jshint esversion : 6 */
/* jshint ignore : start */


mmodule.exports = connection => {
    return function createStore(dbName, { storeName, autoIncrement, keyPath, indexes = [] }) {
        return new Promise(resolve => {

            let store;

            connection.open({
                dbName,
                onsuccess: async({ version, idb }) => {
                    //
                    version++;
                    await connection.close(idb);
                    //
                    connection.open({
                        dbName,
                        version,
                        onupgradeneeded: ({ idb }) => {
                            try {
                                store = idb.createObjectStore(storeName, { autoIncrement, keyPath });
                                indexes.forEach(index => {
                                    const { name, keyPath, objectParameters } = index;
                                    store.createIndex(name, keyPath, objectParameters);
                                });
                            } catch (err) {
                                connection.close(idb);
                                throw err;
                            }
                        },
                        onsuccess: async() => {
                            await connection.close(idb);
                            resolve(store);
                        },
                        onerror: e => { throw e; },
                        onabort: e => { throw e; },
                        onclose: e => { throw e; }
                    });
                }
            });
        });
    }
};