/* jshint esversion : 6 */
/* jshint ignore : start */

module.exports = connection => {
    return function deleteStore(dbName, storeName) {
        return new Promise(resolve => {
            connection.open({
                dbName,
                onsuccess: async({ version, idb }) => {
                    //
                    version++;
                    await connection.close(idb);
                    //
                    connection.open({
                        dbName,
                        version,
                        onupgradeneeded: ({ idb }) => {
                            try {
                                idb.deleteObjectStore(storeName);
                            } catch (err) {
                                connection.close(idb);
                                throw new err;
                            }
                        },
                        onsuccess: async() => {
                            await connection.close(idb);
                            resolve({ success: true, notify: null });
                        },
                        onerror: e => { throw e; },
                        onabort: e => { throw e; },
                        onclose: e => { throw e; }
                    });
                }
            });

        });
    };

};