/* jshint esversion : 6 */
/* jshint ignore : start */


module.exports = connection => {

    const Indexes = {};

    Indexes.names = ({ dbName, storeName }) => {
        return new Promise(resolve => {
            connection.open({
                dbName,
                onsuccess: async({ idb }) => {
                    const objectStore = idb.transaction(storeName);
                    const names = Array.from(objectStore.indexNames);
                    //
                    await connection.close(idb);
                    resolve(names);
                },
                onerror: e => { throw e; },
                onabort: e => { throw e; },
                onclose: e => { throw e; }
            });
        });
    };


    Indexes.check = (objectStore, config) => {
        //
        const curr = Array.from(objectStore.indexNames);
        const configIndexesNames = config.map(e => e.name);
        //
        return {
            toDelete: curr.filter(e => {
                if (configIndexesNames.indexOf(e) === -1)
                    return e;
            }),

            toAdd: config.filter(e => {
                if (curr.indexOf(e.name) === -1)
                    return e;
            }),

            toModify: config.filter(e => {
                const i = curr.indexOf(e.name);
                if (i > -1 && !equals(curr[i], e))
                    return e;
            }),

            get isChange() {
                return (this.toDelete.length + this.toAdd.length + this.toModify.length) > 0;
            }
        };
    };


    return Indexes;
};