/* jshint esversion : 6 */
/* jshint ignore : start */


module.exports = connection => {

    const KeyPath = {};

    KeyPaths.get = ({ dbName, storeName }) => {
        return new Promise(resolve => {
            connection.open({
                dbName,
                onsuccess: async({ idb }) => {
                    const objectStore = idb.transaction(storeName);
                    const keyPath = Array.from(objectStore.keyPath);
                    //
                    await connection.close(idb);
                    resolve(keyPath);
                },
                onerror: e => { throw e; },
                onabort: e => { throw e; },
                onclose: e => { throw e; }
            });
        });
    };


    KeyPath.check = (objectStore, config) => {

        const curr = Array.from(objectStore.keyPath);

        return {
            toDelete: curr.filter(e => {
                if (config.indexOf(e) === -1)
                    return e;
            }),

            toAdd: config.filter(e => {
                if (curr.indexOf(e) === -1)
                    return e;
            }),

            get isChange() {
                return (this.toDelete.length + this.toAdd.length) > 0;
            }
        };
    };


    return KeyPath;
};