/* jshint esversion : 6 */

const IDBKeyRange = require('./key-range');
const IDBTransaction = require('./transaction');
const connection = require('../idb/connection');


exports.Insert = require('./insert')({ connection, IDBKeyRange, IDBTransaction, Helpers });
exports.Cursor = require('./cursor')({ connection, IDBKeyRange, IDBTransaction, Helpers });
exports.Get = require('./get')({ connection, IDBKeyRange, IDBTransaction, Helpers });
exports.GetAll = require('./getAll')({ connection, IDBKeyRange, IDBTransaction, Helpers });
exports.Delete = require('./delete')({ connection, IDBKeyRange, IDBTransaction, Helpers });
//
exports.CursorUpdate = function({ query }) {
    if (!query.data) throw 'no data to insert';
    query.cmd = 'update';
    return this.Cursor();
};
exports.CursorDelete = function({ query }) {
    if (!query.data && !query.where) throw 'no condition for delete row';
    query.cmd = 'delete';
    return this.Cursor();
};
exports.BulkUpdate = require('./bulk-update')();