/* jshint esversion : 6 */
/* jshint ignore : start */


module.exports = function({ connection, IDBKeyRange, IDBTransaction }) {


    return function Insert({ dbName, storeNames, query: { cmd = 'put', key, data } }) {
        return new Promise(resolve => {
            /* jshint ignore : start */
            connection.open({
                dbName,
                onsuccess: function({ idb }) {

                    let result;
                    try {

                        let KeyRange;
                        if (IDBKeyRange.test(key)) KeyRange = IDBKeyRange.set(key.limit, key.range);

                        const tx = IDBTransaction({ idb, storeNames, flag: "readwrite" });
                        tx.oncomplete = async ev => {
                            await connection.close(idb);
                            resolve(result);
                        };
                        tx.onerror = async ev => {
                            await connection.close(idb);
                            throw ev;
                        };
                        tx.onabort = async ev => {
                            await connection.close(idb);
                            throw ev;
                        };
                        //
                        //
                        const storeTx = tx.objectStore(storeNames);
                        const insert = key ? storeTx[cmd](data, KeyRange) : storeTx[cmd](data);
                        insert.onsuccess = ev => result = ev.target.result;
                        insert.onerror = async ev => {
                            await connection.close(idb);
                            throw ev;
                        };

                    } catch (e) {
                        connection.close(idb);
                        throw e;
                    }



                },
                onerror: e => { throw e; },
                onabort: e => { throw e; },
                onclose: e => { throw e; }
            });
            /* jshint ignore : end */
        });

    };

};