/* jshint esversion : 6 */

const IDBOpenRequest = require('./IDBOpenRequest');
const IDBCloseConnection = require('./IDBCloseConnection');
const isChangeConfig = require('../IDBObjectStores/assets/isChangeConfig');
module.exports = IDBCheckStoreConfig;



function IDBCheckStoreConfig({ storesConfig: a, dbName }) {
    return new Promise(resolve => {
        const configs = {};

        IDBOpenRequest({
            dbName,
            onsuccess: ({ idb }) => {

                const execConfig = () => {
                    let i = 0;

                    for (; i < a.length; i++) {
                        if (idb.objectStoreNames.contains(a[i].storeName) && !isChangeConfig({ idb, store: a[i] }))
                            continue;

                        configs[a[i].storeName] = a[i];
                    }

                    return (Object.keys(configs).length > 0);
                };

                resolve({ exec: execConfig(), configs });
                IDBCloseConnection(idb);
            },
            onerror: e => { throw e; },
            onabort: e => { throw e; },
            onclose: e => { throw e; },
        });
    });
}