/* jshint esversion : 6 */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
            |                       |
    r[0]    |   NAME                |
            |   name                |
_ _ _ _ _ _ | _ _ _ _ _ _ _ _ _ _ _ | _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
            |                       |
    r[1]    |   KEY_PATH            |
            |   keyPath             |
_ _ _ _ _ _ | _ _ _ _ _ _ _ _ _ _ _ | _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
            |                       |
    r[2]    |   OBJECT_PARAMETERS   |   unique : will add an entry for each el when the keyPath resolves to an Array
            |   objectParameters    |
            |                       |   multiEntry : will add one single entry containing the Array
            |                       |
            |                       |
            |                       |
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
module.exports = IDBIndex;

function IDBIndex({ name, keyPath, unique = false, multiEntry = false }) {
    return {
        name,
        keyPath: keyPath ? (multiEntry && 'string' === typeof keyPath ? [keyPath] : keyPath) : name,
        objectParameters: { unique, multiEntry }
    };
}