/* jshint esversion : 6 */
const IDBOpenRequest = require('./IDBOpenRequest');
const IDBCloseConnection = require('./IDBCloseConnection');
module.exports = IDBObjectStoreNames;


/* jshint ignore: start */

function IDBObjectStoreNames({ dbName }) {
    return new Promise(resolve => {
        IDBOpenRequest({
            dbName,
            onsuccess: ({ idb }) => {
                const objectStoreNames = Array.from(idb.objectStoreNames);
                resolve(objectStoreNames);
                IDBCloseConnection(idb);
            },
            onerror: e => { throw e; },
            onabort: e => { throw e; },
            onclose: e => { throw e; }
        });
    });
}


/* jshint ignore: end */