/* jshint esversion : 6 */

module.exports = IDBTransaction;

function IDBTransaction({ idb, storeNames, flag }) {
    const _getObjectStores = (storeRequest, storeNames) => {
        // check if exist all objectStore requested
        const excluded = [];
        const validStores = storeRequest.reduce((curr, next) => {
            storeNames.indexOf(next) > -1 ? curr.push(next) : excluded.push(next);
            return curr;
        }, []);

        if (excluded.length)
            throw new Error(`stores ${excluded.join()} not exist`);

        return validStores;
    };




    const mode = !flag ? "readwrite" : flag;
    let storeRequest;

    const objectStoreNames = Array.from(idb.objectStoreNames);
    if ("string" === typeof storeNames) {
        storeRequest = (storeNames === '*') ? objectStoreNames : [storeNames];
    } else
        storeRequest = storeNames;


    // objectStores to use for transaction
    const objectStores = _getObjectStores(storeRequest, objectStoreNames);

    return idb.transaction(objectStores, mode);
}