/* jshint esversion : 6 */

const IDBOpenRequest = require('../../IDB/IDBOpenRequest');
const IDBCloseConnection = require('../../IDB/IDBCloseConnection');

module.exports = deleteObjectStore;


function deleteObjectStore({ db: { dbName }, store: { storeName } }) {
    return new Promise(resolve => {
        IDBOpenRequest({
            dbName,
            onsuccess: ({ version, idb }) => {

                version++;
                IDBCloseConnection(idb);

                IDBOpenRequest({
                    dbName,
                    version,
                    onupgradeneeded: ({ idb }) => {
                        try {
                            idb.deleteObjectStore(storeName);
                        } catch (err) {
                            throw new Error(err);
                        }
                    },
                    onsuccess: () => {
                        resolve({ success: true, notify: null });
                        IDBCloseConnection(idb);
                    },
                    onerror: e => { throw e; },
                    onabort: e => { throw e; },
                    onclose: e => { throw e; }
                });
            }
        });
    });
}