/* jshint esversion : 6 */

const IDBOpenRequest = require('../../IDB/IDBOpenRequest');
const IDBCloseConnection = require('../../IDB/IDBCloseConnection');

module.exports = indexNames;

function indexNames({ dbName, storeName }) {
    return new Promise(resolve => {
        IDBOpenRequest({
            dbName,
            onsuccess: ({ idb }) => {
                const objectStore = idb.transaction(storeName);
                const indexNames = Array.from(objectStore.indexNames);
                resolve(indexNames);
                IDBCloseConnection(idb);
            },
            onerror: e => { throw e; },
            onabort: e => { throw e; },
            onclose: e => { throw e; }
        });
    });
}