/* jshint esversion : 6 */

const isKeyPathChange = require('./isKeyPathChange');
const areIndexesChange = require('./areIndexesChange');

module.exports = isChangeConfig;



function isChangeConfig({ idb, store: { storeName, autoIncrement, keyPath, indexes } }) {

    const objectStore = idb.transaction(storeName).objectStore(storeName);

    const kp = isKeyPathChange(objectStore, keyPath);
    const id = areIndexesChange(objectStore, indexes);

    const $this_autoIncrement = (
        autoIncrement == null ||
        typeof autoIncrement === 'undefined' ||
        autoIncrement == 0
    ) ? false : true;

    const $new_autoincrement = (
        objectStore.autoincrement == null ||
        typeof objectStore.autoincrement === 'undefined' ||
        objectStore.autoincrement == 0
    ) ? false : true;



    return (
        $this_autoIncrement !== $new_autoincrement ||
        kp.isChange ||
        id.isChange
    );
}