/* jshint esversion : 6 */

const IDBOpenRequest = require('../../IDB/IDBOpenRequest');
const IDBCloseConnection = require('../../IDB/IDBCloseConnection');

module.exports = keyPath;


function keyPath({ dbName, storeName }) {
    return new Promise(resolve => {
        IDBOpenRequest({
            dbName,
            onsuccess: ({ idb }) => {
                const objectStore = idb.transaction(storeName);
                const keyPath = Array.from(objectStore.keyPath);
                resolve(keyPath);
                IDBCloseConnection(idb);
            },
            onerror: e => { throw e; },
            onabort: e => { throw e; },
            onclose: e => { throw e; }
        });
    });
}