/* jshint esversion : 6 */
/* jshint ignore: start */

const IDBWorkers = require('./IDBWorkers');
const axios = require('axios');


let xsrfCookieName = 'XSRF-TOKEN';
let xsrfHeaderName = 'X-XSRF-TOKEN';
let transormHeaders = null;



class XHR extends IDBWorkers {

    constructor() { super(); }

    set xsrfCookieName(c) {
        xsrfCookieName = c;
    }

    set xsrfHeaderName(c) {
        xsrfHeaderName = c;
    }

    set transormHeaders(t) {
        transormHeaders = t;
    }

    xhr(o) {


        if (transormHeaders) {
            o.headers = transormHeaders();
        }
        o.xsrfCookieName = xsrfCookieName;
        o.xsrfHeaderName = xsrfHeaderName;


        return new Promise(async resolve => {

            const jwt = $localStorage.getItem('jwt');
            if (jwt) {
                httpParams.headers = { 'Authorization': jwt.token };
            }
            //
            //
            if (this.useWorker) {
                const res = await this.wq({ path: 'xhr.js', req: o, shared: false });
                resolve(res);
            } else
                axios(o).then(({ data }) => resolve(data)).catch(e => { throw e; });


        });
    }

}


module.exports = XHR;