/* jshint esversion : 6 */


const _Cursor = require('./__Cursor');


module.exports = function({ IDBOpenRequest, IDBCloseConnection, isKeyRange, IDBKeyRange, IDBTransaction }) {

    const Cursor = _Cursor({ IDBOpenRequest, IDBCloseConnection, isKeyRange, IDBKeyRange, IDBTransaction });

    return function CursorDelete(o, notify) {
        if (!o.query) o.query = {};
        o.query.cmd = 'delete';

        if (o.data) o.query.data = o.data;

        if (o.where) {
            o.query.where = o.where;
            delete o.where;
        } else if (o.onKeyUpdate) {
            o.query.onKeyUpdate = o.onKeyUpdate;
            delete o.onKeyUpdate;
        }

        if (!o.hasOwnProperty('where'))
            o.query.onKeyUpdate = true;

        return Cursor(o, notify);
    };

};