/* jshint esversion : 6 */


const _Cursor = require('./__Cursor');


module.exports = function({ IDBOpenRequest, IDBCloseConnection, isKeyRange, IDBKeyRange, IDBTransaction }) {

    const Cursor = _Cursor({ IDBOpenRequest, IDBCloseConnection, isKeyRange, IDBKeyRange, IDBTransaction });

    return function CursorUpdate(o, notify) {

        if (!o.query) o.query = {};

        if (o.data) o.query.data = o.data;

        if (o.where) {
            o.query.where = o.where;
            delete o.where;
        } else if (o.onKeyUpdate) {
            o.query.onKeyUpdate = o.onKeyUpdate;
            delete o.onKeyUpdate;
        }

        if (!Object.keys(o.query).length)
            throw new Error('update need "query" => {data:*, where:?, onKeyUpdate:?} parameter\, or "data" and "where" or "onKeyUpdate" parameters');
        else if (o.query.data && !o.hasOwnProperty('where'))
            o.query.onKeyUpdate = true;

        o.query.cmd = 'update';

        return Cursor(o, notify);
    };
};