/* jshint esversion : 6 */

module.exports = function({ IDBOpenRequest, IDBCloseConnection, isKeyRange, IDBKeyRange, IDBTransaction }) {

    /* jshint ignore : start */
    return function Get({ dbName, storeNames, cmd, key }) {
            return new Promise(resolve => {

                IDBOpenRequest({
                    dbName,
                    onsuccess: function({ idb }) {

                        try {

                            const k = isKeyRange(key) ? IDBKeyRange(key.limit, key.range) : key;

                            const tx = IDBTransaction({ idb, storeNames, flag: "readonly" });
                            const storeTx = (key && key.onIndex) ? tx.objectStore(storeNames).index(key.onIndex) : tx.objectStore(storeNames);
                            const get = storeTx[cmd](k);

                            let result;
                            //
                            get.onsuccess = ev => result = ev.target.result;

                            tx.oncomplete = ev => {
                                resolve(result);
                                IDBCloseConnection(idb);
                            };
                            tx.onerror = ev => {
                                IDBCloseConnection(idb);
                                throw ev;
                            };
                            tx.onabort = ev => {
                                IDBCloseConnection(idb);
                                throw ev;
                            };
                        } catch (e) {
                            IDBCloseConnection(idb);
                            throw e;
                        }

                    },
                    onerror: e => { throw e; },
                    onabort: e => { throw e; },
                    onclose: e => { throw e; }
                });

            });

        }
        /* jshint ignore : end */

};