/* jshint esversion : 6 */

const { orderBy } = require('app-utilities');


module.exports = function({ IDBOpenRequest, IDBCloseConnection, isKeyRange, IDBKeyRange, IDBTransaction }) {


    /* jshint ignore : start */
    return function GetAll({ dbName, storeNames, cmd, key, count, query = {} }) {
            return new Promise(resolve => {
                IDBOpenRequest({
                    dbName,
                    onsuccess: function({ idb }) {

                        try {

                            let k;
                            if (isKeyRange(key)) k = IDBKeyRange(key.limit, key.range);

                            const tx = IDBTransaction({ idb, storeNames, flag: "readonly" });
                            const storeTx = (key && key.onIndex) ? tx.objectStore(storeNames).index(key.onIndex) : tx.objectStore(storeNames);


                            const getAll = k ? (count ? storeTx[cmd](k, count) : storeTx[cmd](k)) : storeTx[cmd]();

                            let result;
                            //
                            getAll.onsuccess = ev => result = ev.target.result;

                            tx.oncomplete = ev => {
                                resolve(result);
                                IDBCloseConnection(idb);
                            };
                            tx.onerror = ev => {
                                IDBCloseConnection(idb);
                                throw ev;
                            };
                            tx.onabort = ev => {
                                IDBCloseConnection(idb);
                                throw ev;
                            };
                        } catch (e) {
                            IDBCloseConnection(idb);
                            throw e;
                        }

                    },
                    onerror: e => { throw e; },
                    onabort: e => { throw e; },
                    onclose: e => { throw e; }
                });
            });
        }
        /* jshint ignore : end */

};



function OrderBy(array, sortPredicate, reverseOrder) {
    return new Promise(reoslve => {
        return orderBy(array, sortPredicate, reverseOrder);
    })

}