/* jshint esversion : 6 */

module.exports = function({ IDBOpenRequest, IDBCloseConnection, isKeyRange, IDBKeyRange, IDBTransaction }) {

    return function Insert({ dbName, storeNames, cmd, data, key }) {
        return new Promise(resolve => {
            /* jshint ignore : start */
            IDBOpenRequest({
                dbName,
                onsuccess: function({ idb }) {

                    let result;
                    try {

                        let k;
                        if (isKeyRange(key)) k = IDBKeyRange(key.limit, key.range);

                        const tx = IDBTransaction({ idb, storeNames, flag: "readwrite" });
                        const storeTx = tx.objectStore(storeNames);
                        const insert = (key != null && "undefined" !== typeof key) ? storeTx[cmd](data, k) : storeTx[cmd](data);

                        insert.onsuccess = ev => result = ev.target.result;

                        insert.onerror = ev => {
                            IDBCloseConnection(idb);
                            throw ev;
                        };

                        tx.oncomplete = ev => {
                            resolve(result);
                            //IDBCloseConnection(idb);
                        };
                        tx.onerror = ev => {
                            IDBCloseConnection(idb);
                            throw ev;
                        };
                        tx.onabort = ev => {
                            IDBCloseConnection(idb);
                            throw ev;
                        };

                    } catch (e) {
                        IDBCloseConnection(idb);
                        throw e;
                    }



                },
                onerror: e => { throw e; },
                onabort: e => { throw e; },
                onclose: e => { throw e; }
            });
            /* jshint ignore : end */
        });

    };

};