/* jshint esversion : 6 */


this.importScripts('assets/$cron.js');


const __crons = {};

/* jshint ignore: start */
this.onconnect = ({ ports: [port] }) => {
    port.onmessage = ({ data }) => execCron(data, e => port.postMessage(e), () => port.close());
};

/* jshint ignore: end */


function execCron(data, callback, done) {

    const { cmd, taskName } = data;
    let $cron = __crons[taskName];


    switch (cmd) {
        case 'create':
        case 'start':
        default:
            if (!$cron) $cron = __crons[data.taskName] = cronTask(data, callback);

            try {
                $cron.start();
            } catch (e) { setTimeout(Function.prototype, 10000); }

            break;

        case 'stop':
            try {
                $cron.stop();
                callback({ msg: 'cron stop succesfly' });
            } catch (ev) {
                callback({ msg: 'cron stop error' });
            }

            break;

        case 'destroy':
            try {
                $cron.destroy();
                delete __crons[taskName];
                callback({ msg: 'cron destroy succesfly' });
            } catch (ev) {
                callback({ msg: 'cron destroy error' });
            }

            done();

            break;
    }
}

function cronTask({ taskName, cronExpression, scheduled = true, timezone }, callback) {
    if (cron.validate(cronExpression))
        cron.schedule(cronExpression, () => callback({ msg: 'cron schedule', taskName }), { scheduled, timezone });
    else
        throw new Error(`"${cronExpression}" is not a valid path`);
}