/* jshint esversion : 6 */

const exists = t => "undefined" !== typeof t && t !== null;
const windowExists = exports.windowExists = "undefined" !== typeof window && exists(window);
const navigatorExists = exports.navigatorExists = windowExists && "undefined" !== navigator && exists(navigator) && navigator in window;
//
const isWorkerAvailable = (e, w, t) => {
    return (
        e &&
        t in w &&
        typeof w[t] !== 'undefined' &&
        w[t] !== null &&
        !/apple/gi.test(navigator.vendor)
    );
};
//
exports.workerAvailable = windowExists && isWorkerAvailable(windowExists, window, 'Worker');
exports.sharedWorkerAvailable = windowExists && isWorkerAvailable(windowExists, window, 'SharedWorker');
exports.serviceWorkerAvailabler = navigatorExists && isWorkerAvailable(navigatorExists, navigator, 'serviceWorker');